# Subscribe to our Newsletter for Updates and Tips

If you want to get updates on new features and tips on how to use Instructor, you can subscribe to our newsletter below to get notified when we publish new content.

<iframe src="https://embeds.beehiiv.com/2faf420d-8480-4b6e-8d6f-9c5a105f917a?slim=true" data-test-id="beehiiv-embed" height="52" frameborder="0" scrolling="no" style="margin: 0; border-radius: 0px !important; background-color: transparent;"></iframe>

## Advanced Topics

1. [Unified Provider Interface in Instructor](posts/announcing-unified-provider-interface.md)
2. [Instructor Implements llms.txt](posts/llms-txt-adoption.md)
3. [Query Understanding: Beyond Embeddings](posts/rag-and-beyond.md)
4. [Achieving GPT-4 Level Summaries with GPT-3.5-turbo](posts/chain-of-density.md)
5. [Basics of Guardrails and Validation in AI Models](posts/validation-part1.md)
6. [Validating Citations in AI-Generated Content](posts/citations.md)
7. [Fine-tuning and Distillation in AI Models](posts/distilation-part1.md)
8. [Enhancing OpenAI Client Observability with LangSmith](posts/langsmith.md)
9. [Logfire Integration with Pydantic](posts/logfire.md)

## AI Development and Optimization

- [Effective Function Caching in Python](posts/caching.md)
- [Fundamentals of Batch Processing with Async in Python](posts/learn-async.md)
- [Streaming Models to Improve Latency](posts/generator.md)
- [Using OpenAI's Batch API for Large-Scale Synthetic Data Generation](../examples/batch_job_oai.md)
- [Implementing Bulk Classification with User-Provided Tags](../examples/bulk_classification.md)
- [Utilizing GPT-4 Vision API for Ad Copy from Product Images](../examples/image_to_ad_copy.md)

## Language Models and Prompting Techniques

- [Least-to-Most Prompting Technique for LLMs](../prompting/decomposition/least_to_most.md)
- [Chain of Verification (CoVe) Method for Improving LLM Accuracy](../prompting/self_criticism/chain_of_verification.md)
- [Cumulative Reasoning to Enhance Model Performance](../prompting/self_criticism/cumulative_reason.md)
- [Reverse Chain of Thought (RCoT) Method for Logical Consistency](../prompting/self_criticism/reversecot.md)

## Integrations and Tools

- [Ollama Integration](../integrations/ollama.md)
- [llama-cpp-python Integration](../integrations/llama-cpp-python.md)
- [Together Compute Integration](../integrations/together.md)
- [Pandas DataFrame Examples](./posts/tidy-data-from-messy-tables.md#defining-a-custom-type)
- [Streaming Response Examples](../concepts/partial.md)

## Media and Resources

- [Course: Structured Outputs with Instructor](https://www.wandb.courses/courses/steering-language-models?x=1)
- [Keynote: Pydantic is All You Need](posts/aisummit-2023.md)
