---
title: Installing Instructor with Pip
description: Learn how to install Instructor and its dependencies using pip for Python 3.9+. Simple setup guide included.
---

Installation is as simple as:

```bash
pip install instructor
```

Instructor has a few dependencies:

- [`openai`](https://pypi.org/project/openai/): OpenAI's Python client.
- [`typer`](https://pypi.org/project/typer/): Build great CLIs. Easy to code. Based on Python type hints.
- [`docstring-parser`](https://pypi.org/project/docstring-parser/): A parser for Python docstrings, to improve the experience of working with docstrings in jsonschema.
- [`pydantic`](https://pypi.org/project/pydantic/): Data validation and settings management using python type annotations.

If you've got Python 3.9+ and `pip` installed, you're good to go.
